/* FaceWare 2.03 Constants & Shared Record */
/* FaceWare 1989-92. All Rights Reserved. */

/* FaceIt commands */
#define	DoLoop 	    0L
#define	DoEvnt    -51L
#define	DoMenu    -52L
#define	DoUpdt2   -53L
#define	DoAuto2   -54L
#define	GetMsg    -55L
#define	GetFWs    157L
/* DialIt commands */
#define	NewDlg   1131L
#define	OpnDlg   1132L
#define	EndDlg   1133L
#define	SetDlg   1134L
#define	GetDlg   1135L
#define	ShoDlg   1136L
#define	ChkDlg   1137L
#define	ExtDlg   1138L
#define	DrwDlg   1139L
#define	WinTxt   1147L
#define	WinFnt   1148L
#define	WinCol   1149L
/* UtilIt commands */
#define	DoInit 	  -61L
#define	DoPrep    -62L
#define	DoUnld    -63L
#define	ChgCur    121L
#define	PstEvt    122L
#define	PopMen    123L
#define	PstNot    124L
#define	SetIdl    131L
#define	EndIdl    132L
#define	ShoAlt    153L
#define	StpAlt    154L
#define	NotAlt    155L
#define	CtnAlt    156L
#define	SetItm1   160L
#define	SetItm2   161L
#define	GetItm    162L
#define	FixFSC    163L
#define	SelFSC    164L
#define	ChkMem    171L
#define	NewBlk    172L
#define	PrgCmd    173L
#define	GetFgC    178L
#define	GetBkC    179L
#define	SetFgC    180L
#define	SetBkC    181L
#define	SetFSS    183L
#define	SetPal2   185L
#define	StdOpn    201L
#define	StdSav    202L
#define	GetRef    205L
#define	SetRef    206L
#define	SetTyp    208L
#define	SndBhd    250L
#define	GetNam    251L
#define	SetNam    252L
#define	MovRec    254L
#define	MovAlt    255L
#define	MovDlg    256L
#define	MovWin    257L
#define	DrgWnd    259L
#define	ShoStr    261L
#define	StpStr    262L
#define	NotStr    263L
#define	CtnStr    264L
#define	GetStd    301L
#define	SetStd    302L
#define	SavDlg    356L
#define	SavWin    357L
#define	GetI2     422L
#define	GetI4     423L
#define	GetR4     425L
#define	GetR8     426L
#define	GetR10    427L
#define	GetR12    428L
#define	SetI2     432L
#define	SetI4     433L
#define	SetR4     435L
#define	SetR8     436L
#define	SetR10    437L
#define	SetR12    438L
#define	SetSub    451L
#define	TrmStr    452L
#define	SetPrm    453L
#define	CnvStr    454L
#define	FndTxt    455L
#define	NumToS    471L
#define	SToNum    481L
#define	GetStr    491L
#define	SetStr    492L
#define	SrtLst    493L
#define	DupLst    494L
/* ViewIt Commands */
#define	AddVew  -1200L
#define	NewWnd  -1201L
#define	EndWnd  -1202L
#define	MdlWnd  -1203L
#define	SizWnd  -1204L
#define MovWnd  -1205L
#define	ShoWnd  -1206L
#define	HidWnd  -1207L
#define	GetWVC  -1208L
#define	GetWnd  -1209L
#define	LnkCtl  -1210L
#define	GetCtl  -1211L
#define	ShoCtl  -1212L
#define	GetVal  -1213L
#define	SetVal  -1214L
#define	OvrCtl  -1215L
#define	AddCtl  -1216L
#define	DrwCtl  -1217L
#define	ScrCtl  -1218L
#define	ActCtl  -1219L
#define	SelCtl  -1220L
#define	DspCtl  -1221L
#define	StlCtl  -1222L
#define	SavCtl  -1223L
#define	SavWnd  -1224L
#define HlpWnd	-1229L

/* function prototypes */
void PrepIt (long x, long b, long v, long r, long f);
void FaceIt (void* thePtr, long m1, long m2, long m3, long m4, long m5);

/* Global FaceWare record */
typedef struct FaceRec {
	short			fHead[8];
	GrafPtr			fOffPort;
	GrafPtr			fCOffPort;
	WindowPtr		fActiveWnd;
	long			fActiveRec;
	short			fActiveID;
	short			fActiveResID;
	short			fMsgCount;
	long			fFlags;
	Ptr				fStuff;
	long			fHeapBuff;
	long			fEnvFlags;
	long			fSleep;
	Rect			fScreenRect;
	Rect			fDragRect;
	long			fFrontSleep;
	long			fBackSleep;
	short			fFiller1;
	Handle			fStdBlock;
	short			fStdCount;
	short			fSysEnvArr[8];
	short			fApplVRef;
	OSType			fCreator;
	long			fRefCon;
	short			fFiller2[7];
	short			fCursor;
	MenuHandle		fFontMenu;
	MenuHandle		fSizeMenu;
	MenuHandle		fStyleMenu;
	MenuHandle		fColorMenu;
	SignedByte		fFiller3;
	SignedByte		fI1Err;
	short			fI2Err;
	long			fI4Err;
	short			fI8Err[4];
	float			fR4Err;
	short			fR8Err[4];
	short			fR10Err[5];
	short			fR12Err[6];
	short			fFiller4[125];
	long			fWDEF;
	long			fGlueData;
	long			fWaitNextEvent;
	long			fNewWindow;
	long			fNewCWindow;
	long			fGetNewWindow;
	long			fGetNewCWindow;
	long			fGetNewDialog;
	long			fDisposeWindow;
	long			fDisposDialog;
	long			fActiveWindow;
	long			fSelectWindow;
	long			fUpdateOther;
	ProcPtr			fFiller5[9];
	EventRecord		fEvent;
/* DialIt subrecord */
	short			dHead[8];
	DialogPtr		dlogptr;
	Ptr				dataptr;
	long			dFlags;
	short			dBaseID;
	short			dPopID;
	short			listID[20];
	float			slope[20];
	float			intercept[20];
	short			dialog[99];
	short			dHit;
	short			dClick;
	EventRecord		dEvent;
/* UtilIt subrecord */
	short			uHead[8];
	short			uI2;
	long			uI4;
	float			uR4;
	short			uR8[4];
	short			uR10[5];
	short			uR12[6];
	Point			uPt;
	Rect			uRect;
	long			uCommand;
	long			uParam[4];
	long			uResult;
	long			uMenuID;
	long			uMenuItem;
	char			uString[256];
	char			uName[256];
	short			uRGB[3];
	Style			uStyle;
	SignedByte		uI1;
	short			uI8[4];
	MenuHandle		uMenuHdl;
/* ViewIt subrecord */
	short			vHead[8];
	short			vErr;
	ProcPtr			vCDEF;
	ControlHandle	vSelectCtl;
	long			vSelectRec;
	short			vSelectID;
/* info returned by enabled items */
	short			wiHit;
	short			wvHit;
	short			wcHit;
	short			wClick;
	EventRecord		wEvent;
/* window info returned by GetWnd */
	WindowPtr		wWindow;
	short			wResID;
	short			wCount;
	short			wvCount;
	short			wiCount;
/* control info returned by GetCtl */
	ControlHandle	cControl;
	short			ciIndex;
	short			cvIndex;
	short			ccIndex;
	short			cBaseID;
/* info copied from "cControl" block... */
	ControlHandle	cNext;
	WindowPtr		cOwner;
	Rect			cRect;
	SignedByte		cVis;
	SignedByte		cHilite;
	short			cValue;
	short			cMin;
	short			cMax;
	Handle			cInfo;
	Handle			cLoData;
	ProcPtr			cAction;
	long			cRefCon;
	char			cTitle[256];
/* info copied from "cInfo" block...*/
	short			cStuff[6];
	long			cTmplRefCon;
	Ptr				cPtr;
	Handle			cHiData;
	ControlHandle	cView;
	Rect			cOldRect;
	Rect			cClip;
	Rect			cContent;
	Rect			cLimit;
	long			cType;
	short			cVarCode;
	ResType			cResType;
	short			cResID;
	Handle			cResHdl;
	long			cPrivate;
	SignedByte		cFiller;
	SignedByte		cCmdKey;
	short			cPnRound;
	Point			cPnSize;
	SignedByte		cTxJust;
	Style			cTxFace;
	short			cTxSize;
	short			cTxFont;
	short			cDataType;
	SignedByte		cDataDigits;
	SignedByte		cDataFormat;
	short			cDataOffset;
	Ptr				cDataPtr;
	short			cStorType;
	long			cStorPtr;
	Handle			cColors;
	ProcPtr			cOverride;
	short			cCount;
	char			cString[256];
/* Local FCMD record & proc address table */
	short			xEntries;
	long			xTable[40];
} *FacePtr;
